//监听扩展程序进程或内容脚本发送请求的请求
const MAX_CONCURRENT_DOWNLOADS = 3; // 最大并发下载数量
let downloadingCount = 0; // 当前下载的数量
let downloadQueue = []; // 等待下载的图片队列

// 启动下载，确保不超过最大并发数量
function startDownload() {
  if (downloadingCount >= MAX_CONCURRENT_DOWNLOADS || downloadQueue.length === 0) {
    return; // 超过最大并发数量或者队列为空时停止
  }

  // 获取队列中的下一张图片
  const nextImageUrl = downloadQueue.shift();
  downloadingCount++;

   // 延迟每个下载之间的时间（比如 1 秒）
  setTimeout(() => {
      let filename = `${nextImageUrl.split('/').pop()}`;
      if(nextImageUrl.indexOf('s-zoom.file')!=-1){
        filename = Date.now()+'.jpg';
      }
      if(nextImageUrl.indexOf('wish.com')!=-1){
          chrome.downloads.download({
            url: nextImageUrl,
            saveAs: false,
            filename: filename,
            conflictAction: 'overwrite'//如果文件名已存在 会覆盖
          }, (downloadId) => {
             // 当下载开始时，回调函数会接收到 downloadId
            console.log('Download started with ID:', downloadId);
            downloadingCount--;
            startDownload();
          });
      }else{
          chrome.downloads.download({
            url: nextImageUrl,
            saveAs: false,
            filename: filename,
            conflictAction: 'uniquify'//如果文件名已存在 会自动加唯一标志
          }, (downloadId) => {
             // 当下载开始时，回调函数会接收到 downloadId
            console.log('Download started with ID:', downloadId);
            downloadingCount--;
            startDownload();
          });
      }
  }, 1000); // 1 秒延迟
    //
}
chrome.downloads.onChanged.addListener(function(delta) {
  if (delta.state && delta.state.current === 'complete') {
    console.log('Download completed:', delta);
  } else if (delta.state && delta.state.current === 'interrupted') {
    console.log('Download failed or was interrupted:', delta);
  }
});
